package java.nio.file;

import java.io.IOException;
import java.util.Objects;
import java.nio.file.attribute.BasicFileAttributes;

public class SimpleFileVisitor<T> implements FileVisitor<T>
{
    protected SimpleFileVisitor() {
    }
    
    @Override
    public FileVisitResult preVisitDirectory(T obj, BasicFileAttributes obj2) throws IOException {
        Objects.requireNonNull(obj);
        Objects.requireNonNull(obj2);
        return FileVisitResult.CONTINUE;
    }
    
    @Override
    public FileVisitResult visitFile(T obj, BasicFileAttributes obj2) throws IOException {
        Objects.requireNonNull(obj);
        Objects.requireNonNull(obj2);
        return FileVisitResult.CONTINUE;
    }
    
    @Override
    public FileVisitResult visitFileFailed(T obj, IOException ex) throws IOException {
        Objects.requireNonNull(obj);
        throw ex;
    }
    
    @Override
    public FileVisitResult postVisitDirectory(T obj, IOException ex) throws IOException {
        Objects.requireNonNull(obj);
        if (ex != null) {
            throw ex;
        }
        return FileVisitResult.CONTINUE;
    }
}
